local assets =
{ 
    Asset("ANIM", "anim/infinity_edge.zip"),
    Asset("ANIM", "anim/swap_infinity_edge.zip"), 

    Asset("IMAGE", "images/inventoryimages/infinity_edge.tex"),
    Asset("ATLAS", "images/inventoryimages/infinity_edge.xml"),
}

local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_object", "swap_infinity_edge", "swap_infinity_edge")
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
	owner.AnimState:Hide("ARM_carry")
	owner.AnimState:Show("ARM_normal")
end

local function onattack(inst, owner, target)
	if math.random() <= TUNING.INFINITY_EDGE_CRIT and target and target.components.health and not target.components.health:IsDead() then
		local crit_dmg = TUNING.INFINITY_EDGE_DMG * (1 - TUNING.INFINITY_EDGE_CRIT_DMG)
		if TUNING.INFINITY_EDGE_CRIT_TYPE == 1 then
			--dano verdadeiro
			target.components.health:DoDelta(-crit_dmg)
		elseif target.components.combat then
			--dano normal
			target.components.combat:GetAttacked(owner, crit_damage, inst)
		end
		if owner.components.talker then
			owner.components.talker:Say("Critical!")
		end
	else
		if owner.components.talker then
			owner.components.talker:ShutUp()
		end
	end
end

local function fn(colour)
    local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddNetwork()
	
	MakeInventoryPhysics(inst)
	
	inst.AnimState:SetBank("infinity_edge")
	inst.AnimState:SetBuild("infinity_edge")
	inst.AnimState:PlayAnimation("idle")
	
	inst:AddTag("weapon")
	inst:AddTag("sharp")

	MakeInventoryFloatable(inst, "med", 0.05, {1.1, 0.5, 1.1}, true, -9)
	
    inst.entity:SetPristine()
	
	if not TheWorld.ismastersim then
		return inst
	end

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.INFINITY_EDGE_DMG)
    inst.components.weapon:SetOnAttack(onattack)
	
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/infinity_edge.xml"
    inst.components.inventoryitem.imagename = "infinity_edge"
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(TUNING.INFINITY_EDGE_DURAB)
    inst.components.finiteuses:SetUses(TUNING.INFINITY_EDGE_DURAB)
    inst.components.finiteuses:SetOnFinished(inst.Remove)
	
	MakeHauntableLaunch(inst)

    inst:AddComponent("inspectable")
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    return inst
end

return  Prefab("infinity_edge", fn, assets)